package com.ho.test.aop.cache.service.common;

import java.util.ArrayList;
import java.util.List;

import org.aopalliance.intercept.MethodInvocation;

public class CacheCleanerInterceptor implements ICacheCleanerInterceptor {

	// -------------------------------------------------------------- CONSTANTS
	// ----------------------------------------------------- PRIVATE ATTRIBUTES
	/**
	 * Contains all the methods name to cache.
	 */
	private List<String> methodsCleaner = new ArrayList<String>();

	/**
	 * Contains the cache interceptor
	 */
	private ICacheInterceptor cache = null;

	// ------------------------------------------------------------- EXCEPTIONS
	// ------------------------------------------------------- INTERNAL CLASSES
	// ----------------------------------------------------------- CONSTRUCTORS
	// --------------------------------------------------------- PUBLIC METHODS

	/**
	 * Method invoke
	 * @param arg0
	 * @return
	 * @throws Throwable
	 * @see org.aopalliance.intercept.MethodInterceptor#invoke(org.aopalliance.intercept.MethodInvocation)
	 */
	public Object invoke(MethodInvocation method) throws Throwable {

		if (-1 != methodsCleaner.indexOf(method.getMethod().getName())) {
			// Erase all the items stored in the cache.
			cache.clear();
		} // end-if
		
		Object output = method.proceed();
		return output;

	}

	// -------------------------------------------------------- PRIVATE METHODS
	// ------------------------------------------------------ PROTECTED METHODS
	// --------------------------------------------- ADVANCED GETTERS & SETTERS
	// ------------------------------------------------------ GETTERS & SETTERS
	public List<String> getMethodsCleaner() {
		return methodsCleaner;
	}

	public void setMethodsCleaner(List<String> methodsCleaner) {
		this.methodsCleaner = methodsCleaner;
	}

	public ICacheInterceptor getCache() {
		return cache;
	}

	public void setCache(ICacheInterceptor cache) {
		this.cache = cache;
	}


	
}