package com.ho.test.aop.cache.service.common;

/**
 * <p>
 * Store a generic pair.
 * </p>
 * 
 * <p>Title: Pair</p>
 * <p>Copyright: Copyright (c) 2010</p>
 * <p>Company: HUO</p>
 * @author Huseyin OZVEREN
 */
public class Pair <FirstType, SecondType> {

    // ----------------------------------------------------- PRIVATE ATTRIBUTES
    
    private FirstType firstElement = null;
    private SecondType secondElement = null;

    // ----------------------------------------------------------- CONSTRUCTORS
    
    public Pair(FirstType first, SecondType second) {
        firstElement = first;
        secondElement = second;
    }
    
    // --------------------------------------------------------- PUBLIC METHODS
    
    /**
     * Use sample : 
     * Object tmp1 = Pair.makeInstance(422.4, "test");
     * Object tmp2 = Pair.makeInstance("4248", "RTRE");
     * --> let the system determine the type.
     */
    public static synchronized <Ftype, Stype> Pair <Ftype, Stype> makeInstance(Ftype firstType, Stype secondType) {
        return new Pair<Ftype, Stype> (firstType, secondType);
    }

    // ------------------------------------------------------ GETTERS & SETTERS
    public FirstType getFirst() {
        return firstElement;
    }
    
    public SecondType getSecond() {
        return secondElement;
    }
        
    public void setFirst(FirstType firstElement){
        this.firstElement = firstElement;
    }
    
    public void setSecond(SecondType secondElement){
        this.secondElement = secondElement;
    }
}