package com.ho.test.mbean.common;

import java.lang.reflect.InvocationTargetException;
import java.util.Collection;
import java.util.Map;

import javax.management.AttributeNotFoundException;
import javax.management.InstanceNotFoundException;
import javax.management.IntrospectionException;
import javax.management.InvalidAttributeValueException;
import javax.management.MBeanAttributeInfo;
import javax.management.MBeanException;
import javax.management.MBeanOperationInfo;
import javax.management.MBeanServer;
import javax.management.MalformedObjectNameException;
import javax.management.ObjectInstance;
import javax.management.ObjectName;
import javax.management.ReflectionException;

public interface IRemoteMbeanService {

	public MBeanVo buildMbeanVo(String name) throws MalformedObjectNameException, NullPointerException, InstanceNotFoundException, IntrospectionException, ReflectionException;

	public Map<MBeanAttributeInfo, Object> getAttributeValues(ObjectName objName) throws InstanceNotFoundException, IntrospectionException, ReflectionException;

	public Map<ObjectName, ObjectInstance> getMbeanByPattern(String... mbeanPattern) throws MalformedObjectNameException, NullPointerException;

	public MBeanVo invoke(String name, String methodName, String[] paramValues, String[] NonVoidMethodName) throws MalformedObjectNameException, NullPointerException, InstanceNotFoundException, IntrospectionException, ReflectionException, ClassNotFoundException, SecurityException, NoSuchMethodException, IllegalArgumentException, IllegalAccessException, InvocationTargetException, MBeanException;

	public Collection<MBeanOperationInfo> listOperations(ObjectName name);

	public MBeanVo updateAttributes(String name, String[] attributeValues, String[] attributeKeys) throws MalformedObjectNameException, NullPointerException, InstanceNotFoundException, IntrospectionException, ReflectionException, ClassNotFoundException, SecurityException, NoSuchMethodException, IllegalArgumentException, IllegalAccessException, InvocationTargetException, AttributeNotFoundException, InvalidAttributeValueException, MBeanException;
}
